Index: java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java	(revision 102)
@@ -132,5 +132,4 @@
 
 	public void send(ProtocolRequest request, ClientSideResponseFuture callback) {
-		//TODO RunAt
 		sendImplementation(request, AtOnceDispatcher.getInstance(), callback);
 	}
@@ -466,5 +465,5 @@
 
 		final String finalEventPath = eventPath;
-				//TODO add arguments to the exception
+		//TODO add arguments to the exception
 		send(new CallRequest().procedure("remove").path(eventPath), dispatcher, new ClientSideResponseFuture(future) {
 
Index: java/main/src/main/java/com/framsticks/communication/Connection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/Connection.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/communication/Connection.java	(revision 102)
@@ -18,5 +18,4 @@
 import java.io.PrintWriter;
 import java.net.Socket;
-import java.net.SocketTimeoutException;
 import java.util.Collection;
 import java.util.HashSet;
@@ -87,8 +86,4 @@
 	public Connection setAddress(String address) {
 		return setAddress(new Address(address));
-	}
-
-	public synchronized boolean isConnected() {
-		return socket != null && socket.isConnected();
 	}
 
@@ -131,10 +126,7 @@
 
 				readChars = 0;
-				while (readChars == 0) {
-					try {
-						readChars = input.read(readBuffer);
-					} catch (SocketTimeoutException ignored) {
-						//timeout - continue
-					}
+				readChars = input.read(readBuffer);
+				if (readChars < 0) {
+					throw new SocketClosedException().msg("socket is closed");
 				}
 				iterator = 0;
@@ -143,5 +135,6 @@
 			throw new InterruptedException();
 		} catch (Exception e) {
-			throw new FramsticksException().msg("failed to read line").cause(e);
+			log.debug("failed to read line (closing): {}", e.getMessage());
+			throw new SocketClosedException().msg("failed to read line").cause(e);
 		}
 	}
@@ -162,9 +155,15 @@
 	protected abstract void processNextInputBatch();
 
+
 	protected final void processInputBatchesUntilClosed() {
-		while (isRunning() && isConnected()) {
+		while (isRunning() && !socket.isClosed()) {
 			try {
 				processNextInputBatch();
+			} catch (SocketClosedException e) {
+				log.log(isRunning() ? Level.ERROR : Level.DEBUG, "socket is closing: {}", e.getShortMessage(new StringBuilder()));
+				// log.log(isRunning() ? Level.ERROR : Level.DEBUG, "caught exception: ", e);
+				break;
 			} catch (FramsticksException e) {
+				log.debug("{} caught exception in receiver thread {}", this, e.getMessage());
 				handle(e);
 			} catch (Exception e) {
@@ -173,4 +172,5 @@
 			}
 		}
+		log.debug("{} finished processing input", this);
 	}
 
@@ -227,5 +227,5 @@
 		Dispatching.use(threads, this);
 
-		senderThread.dispatch(new RunAt<Connection>(ThrowExceptionHandler.getInstance()) {
+		senderThread.dispatch(new RunAt<Connection>(this) {
 			@Override
 			protected void runAt() {
@@ -238,10 +238,10 @@
 		});
 
-		receiverThread.dispatch(new RunAt<Connection>(ThrowExceptionHandler.getInstance()) {
+		receiverThread.dispatch(new RunAt<Connection>(this) {
 			@Override
 			protected void runAt() {
 				receiverThreadRoutine();
 				interruptJoinable();
-				finishJoinable();
+				// finishJoinable();
 			}
 		});
@@ -260,10 +260,10 @@
 
 	protected static void startClientConnection(Connection connection) {
-		while (connection.isRunning() && !connection.isConnected()) {
+		while (connection.isRunning() && connection.socket == null) {
 			log.debug("connecting to {}", connection.address);
 			try {
 				connection.socket = new Socket(connection.getAddressObject().getHostName(), connection.getAddressObject().getPort());
 			} catch (IOException e) {
-				log.info("{} failed to connect (retrying): ", connection, e);
+				log.warn("{} failed to connect (retrying): {}", connection, e.getMessage());
 				Dispatching.sleep(0.5);
 			}
@@ -272,5 +272,5 @@
 		log.debug("{} connected", connection);
 		try {
-			connection.socket.setSoTimeout(500);
+			// connection.socket.setSoTimeout(500);
 			connection.setupStreams();
 		} catch (Exception e) {
@@ -319,4 +319,5 @@
 	@Override
 	public void handle(FramsticksException exception) {
+		log.debug("{} handling {}", this, exception.getMessage());
 		exceptionHandler.handle(exception);
 	}
@@ -358,3 +359,7 @@
 	}
 
+	public synchronized boolean isConnected() {
+		return socket != null && socket.isConnected();
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java	(revision 102)
@@ -32,7 +32,4 @@
 
 
-	protected void processNextInputBatch() {
-		processNextRequest();
-	}
 
 	@Override
@@ -92,5 +89,5 @@
 
 
-	protected void processNextRequest() {
+	protected void processNextInputBatch() {
 		final Holder<Integer> id = new Holder<>();
 		final String line = getLine();
@@ -106,5 +103,4 @@
 			}
 
-			//TODO what to do here?
 			handleRequest(request, new ServerSideResponseFuture() {
 				@Override
Index: java/main/src/main/java/com/framsticks/communication/SocketClosedException.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/SocketClosedException.java	(revision 102)
+++ java/main/src/main/java/com/framsticks/communication/SocketClosedException.java	(revision 102)
@@ -0,0 +1,8 @@
+package com.framsticks.communication;
+
+import com.framsticks.util.FramsticksException;
+
+@SuppressWarnings("serial")
+public class SocketClosedException extends FramsticksException {
+
+}
Index: java/main/src/main/java/com/framsticks/core/AbstractTree.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/AbstractTree.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/core/AbstractTree.java	(revision 102)
@@ -34,5 +34,4 @@
 import com.framsticks.util.dispatching.JoinableState;
 import com.framsticks.util.dispatching.RunAt;
-import com.framsticks.util.dispatching.Thread;
 import com.framsticks.util.dispatching.ThrowExceptionHandler;
 import com.framsticks.util.lang.Pair;
@@ -42,5 +41,5 @@
  */
 @FramsClassAnnotation
-public abstract class AbstractTree extends AbstractJoinable implements Dispatcher<Tree>, Tree, JoinableParent, NeedFileAcceptor {
+public abstract class AbstractTree extends AbstractJoinable implements Tree, JoinableParent, NeedFileAcceptor {
 
 	private static final Logger log = LogManager.getLogger(AbstractTree.class);
@@ -49,5 +48,5 @@
 	private ExceptionResultHandler handler = ThrowExceptionHandler.getInstance();
 
-	protected final BufferedDispatcher<Tree> bufferedDispatcher = new BufferedDispatcher<>();
+	protected final BufferedDispatcher<Tree> bufferedDispatcher = new BufferedDispatcher<>(this);
 
 	protected final PriorityQueue<Pair<Integer, NeedFileAcceptor>> needFileAcceptors = new PriorityQueue<>(32, new Comparator<Pair<Integer, NeedFileAcceptor>>() {
@@ -77,5 +76,5 @@
 	public void assignRootObject(Object object) {
 		if (root == null) {
-			throw new FramsticksException().msg("root is has no type specified");
+			throw new FramsticksException().msg("root has no type specified");
 		}
 		if (root.getObject() != null) {
@@ -89,5 +88,5 @@
 	public @Nonnull Node getAssignedRoot() {
 		if (root == null) {
-			throw new FramsticksException().msg("root has no type specified yet");
+			throw new FramsticksException().msg("root has no type specified yet").arg("in", this);
 		}
 		return root;
@@ -173,5 +172,5 @@
 	@Override
 	public Dispatcher<Tree> getDispatcher() {
-		return bufferedDispatcher.getTargetDispatcher();
+		return bufferedDispatcher;
 	}
 
@@ -181,7 +180,4 @@
 	@Override
 	public void setDispatcher(Dispatcher<Tree> dispatcher) {
-		if (bufferedDispatcher.getTargetDispatcher() != null) {
-			throw new FramsticksException().msg("dispatcher is already set").arg("tree", this).arg("dispatcher", bufferedDispatcher.getTargetDispatcher());
-		}
 		bufferedDispatcher.setTargetDispatcher(dispatcher);
 	}
@@ -213,13 +209,11 @@
 	@Override
 	protected void joinableStart() {
-		if (bufferedDispatcher.getTargetDispatcher() == null) {
-			bufferedDispatcher.setTargetDispatcher(new Thread<Tree>());
-		}
-		Dispatching.use(bufferedDispatcher.getTargetDispatcher(), this);
+		bufferedDispatcher.createThreadIfNeeded();
+		Dispatching.use(bufferedDispatcher, this);
 	}
 
 	@Override
 	protected void joinableInterrupt() {
-		Dispatching.drop(bufferedDispatcher.getTargetDispatcher(), this);
+		Dispatching.drop(bufferedDispatcher, this);
 	}
 
@@ -231,10 +225,10 @@
 	@Override
 	protected void joinableJoin() throws InterruptedException {
-		Dispatching.join(bufferedDispatcher.getTargetDispatcher());
+		Dispatching.join(bufferedDispatcher);
 	}
 
 	@Override
 	public void childChangedState(Joinable joinable, JoinableState state) {
-		if (joinable == bufferedDispatcher.getTargetDispatcher()) {
+		if (joinable == bufferedDispatcher) {
 			proceedToState(state);
 		}
@@ -333,5 +327,5 @@
 					}
 				}
-				throw new FramsticksException().msg("failed to find need file acceptor in tree").arg("tree", AbstractTree.this);
+				throw new FramsticksException().msg("failed to find need file acceptor in tree").arg("tree", AbstractTree.this).arg("needfile", needFile);
 			}
 		});
Index: java/main/src/main/java/com/framsticks/core/ListChange.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/ListChange.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/core/ListChange.java	(revision 102)
@@ -1,3 +1,9 @@
 package com.framsticks.core;
+
+import java.util.Arrays;
+import java.util.Set;
+import java.util.TreeSet;
+
+import org.apache.commons.lang.StringUtils;
 
 import com.framsticks.params.annotations.FramsClassAnnotation;
@@ -9,15 +15,24 @@
  * @author Piotr Sniegowski
  */
-@FramsClassAnnotation(order = {"type", "pos", "id"})
+@FramsClassAnnotation(order = {"type", "pos", "id", "hint"})
 public class ListChange {
 
+	public static enum Action {
+		Add,
+		Remove,
+		Modify
+	}
 
-	/**
-	 * @param action
-	 */
-	public ListChange(Action action, Integer position, String identifier) {
+
+	public ListChange(Action action, Integer position, String identifier, Object... hints) {
 		this.action = action;
 		this.position = position;
 		this.identifier = identifier;
+		if (hints.length != 0) {
+			this.hints = new TreeSet<>();
+			for (Object h : hints) {
+				this.hints.add(h.toString());
+			}
+		}
 	}
 
@@ -40,22 +55,12 @@
 	}
 
-	public static enum Action {
-		Add,
-		Remove,
-		Modify
-		// Add(0),
-		// Remove(1),
-		// Modify(2);
 
-		// public final int value;
+	public boolean hasHint(String hint) {
+		if (hints == null) {
+			return false;
+		}
+		return hints.contains(hint);
+	}
 
-		// /**
-		//  * @param value
-		//  */
-		// Action(int value) {
-		//	this.value = value;
-		// }
-
-	}
 
 	public Action action = Action.Add;
@@ -64,4 +69,21 @@
 	@ParamAnnotation(id = "id")
 	public String identifier;
+
+	protected Set<String> hints;
+
+	@ParamAnnotation
+	public String getHints() {
+		return StringUtils.join(hints, ",");
+	}
+
+	@ParamAnnotation
+	public void setHints(String hints) {
+		if (!Strings.notEmpty(hints)) {
+			this.hints = null;
+			return;
+		}
+		this.hints = new TreeSet<>();
+		this.hints.addAll(Arrays.asList(StringUtils.split(hints, ",")));
+	}
 
 	@ParamAnnotation
@@ -79,5 +101,10 @@
 	@Override
 	public String toString() {
-		return action + " " + identifier + " " + position;
+		StringBuilder b = new StringBuilder();
+		b.append(action).append(" ").append(identifier).append(" ").append(position);
+		if (hints != null && !hints.isEmpty()) {
+			b.append(" ").append(getHints());
+		}
+		return b.toString();
 	}
 
@@ -86,5 +113,5 @@
 		if (object instanceof ListChange) {
 			ListChange r = (ListChange) object;
-			return Misc.equals(action, r.action) && Misc.equals(position, r.position) && Misc.equals(identifier, r.identifier);
+			return Misc.equals(action, r.action) && Misc.equals(position, r.position) && Misc.equals(identifier, r.identifier) && Misc.equals(hints, r.hints);
 		}
 		return false;
Index: java/main/src/main/java/com/framsticks/core/LocalTree.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/LocalTree.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/core/LocalTree.java	(revision 102)
@@ -15,4 +15,6 @@
 import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.Dispatcher;
+import com.framsticks.util.dispatching.DispatcherSetable;
 import com.framsticks.util.dispatching.Dispatching;
 import com.framsticks.util.dispatching.Future;
@@ -33,7 +35,8 @@
 	public LocalTree() {
 		super();
-
+		bufferedDispatcher.setBuffer(false);
 	}
 
+	@SuppressWarnings({ "rawtypes", "unchecked" })
 	@AutoAppendAnnotation
 	public void setRootObject(Object object) {
@@ -49,15 +52,20 @@
 			joinableRootObject = (Joinable) object;
 		}
+		if (object instanceof DispatcherSetable) {
+			DispatcherSetable<?> setable = (DispatcherSetable<?>) object;
+			setable.setDispatcher((Dispatcher) this);
+		}
 	}
 
 	public Object getRootObject() {
-		return getAssignedRoot().getObject();
+		Object result = getAssignedRoot().getObject();
+		if (result == null) {
+			throw new FramsticksException().msg("object tree is empty").arg("tree", this);
+		}
+		return result;
 	}
 
 	public <T> T getRootObject(Class<T> type) {
 		Object result = getRootObject();
-		if (result == null) {
-			throw new FramsticksException().msg("object tree is empty").arg("tree", this);
-		}
 		if (!type.isInstance(result)) {
 			throw new FramsticksException().msg("object tree holds object of different kind").arg("object", result).arg("requested", type).arg("tree", this);
@@ -181,3 +189,4 @@
 		}
 	}
+
 }
Index: java/main/src/main/java/com/framsticks/core/Tree.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Tree.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/core/Tree.java	(revision 102)
@@ -13,9 +13,10 @@
 import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.util.dispatching.Dispatcher;
+import com.framsticks.util.dispatching.DispatcherSetable;
 import com.framsticks.util.dispatching.ExceptionResultHandler;
 import com.framsticks.util.dispatching.Future;
 import com.framsticks.util.dispatching.Joinable;
 
-public interface Tree extends Dispatcher<Tree>, Joinable, ExceptionResultHandler {
+public interface Tree extends Dispatcher<Tree>, DispatcherSetable<Tree>, Joinable, ExceptionResultHandler {
 
 	public @Nonnull Node getAssignedRoot();
@@ -54,7 +55,7 @@
 	public ExceptionResultHandler getExceptionHandler();
 
-	public void setDispatcher(Dispatcher<Tree> dispatcher);
+	// public void setDispatcher(Dispatcher<Tree> dispatcher);
 
-	public Dispatcher<Tree> getDispatcher();
+	// public Dispatcher<Tree> getDispatcher();
 
 	public <A> void addListener(Path path, EventParam param, EventListener<A> listener, Class<A> argumentType, Future<Void> future);
Index: java/main/src/main/java/com/framsticks/core/TreeOperations.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/TreeOperations.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/core/TreeOperations.java	(revision 102)
@@ -44,6 +44,5 @@
 	public static final SideNoteKey<Boolean> FETCHED_MARK = SideNoteKey.make(Boolean.class);
 
-	public static @Nonnull
-	FramsClass processFetchedInfo(Tree tree, File file) {
+	public static @Nonnull FramsClass processFetchedInfo(Tree tree, File file) {
 		assert tree.isActive();
 		FramsClass framsClass = Loaders.loadFramsClass(file.getContent());
Index: java/main/src/main/java/com/framsticks/dumping/PrintWriterSink.java
===================================================================
--- java/main/src/main/java/com/framsticks/dumping/PrintWriterSink.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/dumping/PrintWriterSink.java	(revision 102)
@@ -1,5 +1,5 @@
 package com.framsticks.dumping;
 
-import com.framsticks.params.SinkInterface;
+import com.framsticks.params.Sink;
 
 import java.io.PrintWriter;
@@ -8,5 +8,5 @@
  * @author Piotr Sniegowski
  */
-public class PrintWriterSink implements SinkInterface {
+public class PrintWriterSink implements Sink {
 
     protected final PrintWriter stream;
Index: java/main/src/main/java/com/framsticks/dumping/SaveStream.java
===================================================================
--- java/main/src/main/java/com/framsticks/dumping/SaveStream.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/dumping/SaveStream.java	(revision 102)
@@ -2,4 +2,5 @@
 
 import static com.framsticks.core.TreeOperations.*;
+import static com.framsticks.params.AccessOperations.*;
 import com.framsticks.core.Node;
 import com.framsticks.core.Path;
@@ -8,5 +9,5 @@
 import com.framsticks.params.FramsClass;
 import com.framsticks.params.ListAccess;
-import com.framsticks.params.SinkInterface;
+import com.framsticks.params.Sink;
 import com.framsticks.parsers.Savers;
 import com.framsticks.core.Tree;
@@ -30,5 +31,5 @@
 	private final static Logger log = LogManager.getLogger(SaveStream.class.getName());
 
-	protected final SinkInterface sink;
+	protected final Sink sink;
 	protected final Tree tree;
 	protected final Future<Void> future;
@@ -38,5 +39,5 @@
 	private int dispatched = 0;
 
-	public SaveStream(SinkInterface sink, Tree tree, Path root, Future<Void> future) {
+	public SaveStream(Sink sink, Tree tree, Path root, Future<Void> future) {
 		assert Dispatching.isThreadSafe();
 		this.sink = sink;
@@ -83,5 +84,5 @@
 				sink.print("file").breakLine();
 				//stream.print("#" + access.getSelected().getClass().getCanonicalName() + "\n");
-				access.save(sink);
+				save(access, sink);
 				sink.print("eof").breakLine();
 				sink.print("ok").breakLine();
Index: java/main/src/main/java/com/framsticks/experiment/AbstractExperimentLogic.java
===================================================================
--- java/main/src/main/java/com/framsticks/experiment/AbstractExperimentLogic.java	(revision 102)
+++ java/main/src/main/java/com/framsticks/experiment/AbstractExperimentLogic.java	(revision 102)
@@ -0,0 +1,21 @@
+package com.framsticks.experiment;
+
+public class AbstractExperimentLogic implements ExperimentLogic {
+
+	protected final Experiment experiment;
+
+	/**
+	 * @param experiment
+	 */
+	public AbstractExperimentLogic(Experiment experiment) {
+		this.experiment = experiment;
+	}
+
+	/**
+	 * @return the experiment
+	 */
+	public Experiment getExperiment() {
+		return experiment;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/experiment/Experiment.java
===================================================================
--- java/main/src/main/java/com/framsticks/experiment/Experiment.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/experiment/Experiment.java	(revision 102)
@@ -2,17 +2,74 @@
 
 import java.util.Map;
+
+import org.apache.logging.log4j.Level;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.core.ListChange;
 import com.framsticks.params.EventListener;
+import com.framsticks.params.ParamFlags;
 import com.framsticks.params.SimpleUniqueList;
 import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.remote.RemoteTree;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.AbstractJoinable;
+import com.framsticks.util.dispatching.BufferedDispatcher;
+import com.framsticks.util.dispatching.Dispatcher;
+import com.framsticks.util.dispatching.DispatcherSetable;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
+import com.framsticks.util.dispatching.Joinable;
 import com.framsticks.util.dispatching.JoinableCollection;
+import com.framsticks.util.dispatching.JoinableParent;
+import com.framsticks.util.dispatching.JoinableState;
+import com.framsticks.util.dispatching.RunAt;
 
 @FramsClassAnnotation
-public class Experiment extends JoinableCollection<Simulator> {
+public class Experiment extends AbstractJoinable implements Dispatcher<Experiment>, DispatcherSetable<Experiment>, JoinableParent, ExceptionResultHandler {
+	private static final Logger log = LogManager.getLogger(Experiment.class);
+
+	protected final JoinableCollection<Simulator> simulatorAsJoinables = new JoinableCollection<Simulator>().setObservableName("simulators");
+
+	protected final JoinableCollection<RemoteTree> simulatorCandidates = new JoinableCollection<RemoteTree>().setObservableName("candidates");
 
 	protected final SimpleUniqueList<Simulator> simulators = new SimpleUniqueList<>(Simulator.class, 's');
+
+	protected final SimpleUniqueList<Simulator> oldSimulators = new SimpleUniqueList<>(Simulator.class, 's');
+
+	protected final BufferedDispatcher<Experiment> bufferedDispatcher = new BufferedDispatcher<>(this);
+
+	protected String expdef;
+
+	/**
+	 *
+	 */
+	public Experiment() {
+		super();
+		bufferedDispatcher.setBuffer(false);
+
+		Dispatching.dispatchLog(this, log, Level.DEBUG, "first task");
+
+
+		simulators.addListener(new EventListener<ListChange>() {
+			@Override
+			public void action(ListChange argument) {
+				if (argument.getAction() == ListChange.Action.Add) {
+					simulators.fireChildrenChange(argument, ListChange.Action.Modify, "ready");
+				}
+			}
+		});
+
+	}
+
+	/**
+	 * @return the simulatorCandidates
+	 */
+	public JoinableCollection<RemoteTree> getSimulatorCandidates() {
+		return simulatorCandidates;
+	}
 
 	@ParamAnnotation
@@ -21,4 +78,41 @@
 	}
 
+	@ParamAnnotation(id = "old_simulators")
+	public Map<String, Simulator> getOldSimulators() {
+		return oldSimulators.getView();
+	}
+
+	/**
+	 * @return the dispatcher
+	 */
+	@Override
+	public Dispatcher<Experiment> getDispatcher() {
+		return bufferedDispatcher;
+	}
+
+	/**
+	 * @param dispatcher the dispatcher to set
+	 */
+	@Override
+	public void setDispatcher(Dispatcher<Experiment> dispatcher) {
+		bufferedDispatcher.setTargetDispatcher(dispatcher);
+	}
+
+	/**
+	 * @return the expdef
+	 */
+	@ParamAnnotation(flags = ParamFlags.USERREADONLY)
+	public String getExpdef() {
+		return expdef;
+	}
+
+	/**
+	 * @param expdef the expdef to set
+	 */
+	@ParamAnnotation
+	public void setExpdef(String expdef) {
+		this.expdef = expdef;
+	}
+
 	@ParamAnnotation(id = "simulators_changed")
 	public void addSimulatorsListener(EventListener<ListChange> listener) {
@@ -34,4 +128,91 @@
 	public void addSimulator(Simulator simulator) {
 		simulators.add(simulator);
-	}
+		simulatorAsJoinables.add(simulator);
+
+
+
+
+
+	}
+
+	protected void removeSimulator(Simulator simulator) {
+		simulatorAsJoinables.remove(simulator);
+		simulators.remove(simulator);
+		oldSimulators.add(simulator);
+	}
+
+	@ParamAnnotation(id = "old_simulators_changed")
+	public void addOldSimulatorsListener(EventListener<ListChange> listener) {
+		oldSimulators.addListener(listener);
+	}
+
+	@ParamAnnotation(id = "old_simulators_changed")
+	public void removeOldSimulatorsListener(EventListener<ListChange> listener) {
+		oldSimulators.removeListener(listener);
+	}
+
+	@Override
+	public String getName() {
+		return "experiment";
+	}
+
+	@Override
+	public void childChangedState(Joinable joinable, JoinableState state) {
+		proceedToState(state);
+	}
+
+	@Override
+	protected void joinableStart() {
+		bufferedDispatcher.createThreadIfNeeded();
+		Dispatching.use(bufferedDispatcher, this);
+
+		Dispatching.use(simulatorAsJoinables, this);
+		Dispatching.use(simulatorCandidates, this);
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+
+		Dispatching.drop(simulatorAsJoinables, this);
+		Dispatching.drop(simulatorCandidates, this);
+
+		finishJoinable();
+	}
+
+	@Override
+	protected void joinableFinish() {
+		log.debug("finishing experiment {}", this);
+	}
+
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+		Dispatching.drop(bufferedDispatcher, this);
+
+		Dispatching.join(simulatorAsJoinables);
+		Dispatching.join(simulatorCandidates);
+		Dispatching.join(bufferedDispatcher.getTargetDispatcher());
+	}
+
+	@Override
+	public void handle(FramsticksException exception) {
+		log.error("caught exception: ", exception);
+	}
+
+	@Override
+	public boolean isActive() {
+		return bufferedDispatcher.isActive();
+	}
+
+	@Override
+	public void dispatch(RunAt<? extends Experiment> runnable) {
+		bufferedDispatcher.dispatch(runnable);
+	}
+
+	@ParamAnnotation(paramType = ProcedureParam.class)
+	public void connectToSimulator(String address) {
+		SimulatorConnector connector = new SimulatorConnector();
+		connector.setAddress(address);
+		connector.attachTo(this);
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/experiment/ExperimentLogic.java
===================================================================
--- java/main/src/main/java/com/framsticks/experiment/ExperimentLogic.java	(revision 102)
+++ java/main/src/main/java/com/framsticks/experiment/ExperimentLogic.java	(revision 102)
@@ -0,0 +1,5 @@
+package com.framsticks.experiment;
+
+public interface ExperimentLogic {
+
+}
Index: java/main/src/main/java/com/framsticks/experiment/NetLoadSaveLogic.java
===================================================================
--- java/main/src/main/java/com/framsticks/experiment/NetLoadSaveLogic.java	(revision 102)
+++ java/main/src/main/java/com/framsticks/experiment/NetLoadSaveLogic.java	(revision 102)
@@ -0,0 +1,76 @@
+package com.framsticks.experiment;
+
+
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+
+import com.framsticks.communication.File;
+import com.framsticks.core.ListChange;
+import com.framsticks.params.EventListener;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.FutureHandler;
+
+@FramsClassAnnotation
+public abstract class NetLoadSaveLogic extends AbstractExperimentLogic {
+	private static final Logger log = LogManager.getLogger(NetLoadSaveLogic.class);
+
+
+	protected String option = "an option";
+
+	/**
+	 * @param experiment
+	 */
+	public NetLoadSaveLogic(Experiment parentExperiment) {
+		super(parentExperiment);
+
+		experiment.addSimulatorsListener(new EventListener<ListChange>() {
+
+			@Override
+			public void action(ListChange argument) {
+				assert experiment.isActive();
+
+				if (argument.hasHint("ready")) {
+					final Simulator simulator = experiment.getSimulators().get(argument.getIdentifier());
+					log.debug("simulator is ready: {}", simulator);
+
+					netload(simulator, new FutureHandler<File>(simulator) {
+
+						@Override
+						protected void result(final File file) {
+							simulator.uploadNet(file, new FutureHandler<Object>(this) {
+
+								@Override
+								protected void result(Object result) {
+									log.debug("netload of {} done", file);
+								}
+							});
+						}
+					});
+				}
+			}
+		});
+	}
+
+	public abstract void netload(Simulator simulator, Future<File> net);
+
+	public abstract void netsave(Simulator simulator, File net);
+
+	/**
+	 * @return the option
+	 */
+	@ParamAnnotation
+	public String getOption() {
+		return option;
+	}
+
+	/**
+	 * @param option the option to set
+	 */
+	@ParamAnnotation
+	public void setOption(String option) {
+		this.option = option;
+	}
+
+}
